#!/bin/bash

RUNDIR=$(pwd)

DWARF_HOME=${RUNDIR}/dwarf-lonlev-0.91_0


# ---- Start compiling section
cd ${DWARF_HOME}
module load gcc/7.2.0

# Add the free length line to the compiling option
FCFLAGS='-ffree-line-length-none -fopenmp -g -O2 -cpp'
sed -i  "/configure / s/$/ FCFLAGS=\'${FCFLAGS}\'/" ./confmake.sh

# Add include folder for dependencies of rp_emulator
INC_FOLDER='MKLINCL:=-I/gpfs/projects/bsc32/bsc32870/rpe/src/src/include/'
sed -i 's@^MKLINCL.*@'${INC_FOLDER}'@' Makefile.include.in

# Add make clean to confmake
sed -i  "s/^make /make clean\nmake/" ./confmake.sh

# Compile
./confmake.sh

echo -e "Executable produced\n"${DWARF_HOME//src}"/dwarf"
